/*
 * drei_d.h
 *
 *  Created on: 19.05.2010
 *      Author: jack
 */

#ifndef DREI_D_H_
#define DREI_D_H_

using namespace std;

class drei_d {
private:
  float x, y, z; // Koordinaten
public:
  drei_d (); //Standardkonstruktor
  drei_d (float i, float j, float k); // Konstruktor
  drei_d (const drei_d& orig); // Copy-Konstruktor
  float betrag(); // Betrag
  drei_d& operator = (const drei_d &rhs); // Zuweisung
  drei_d operator + (const drei_d &rhs); // Addition
  drei_d operator - (const drei_d &rhs); // Substraktion
  drei_d operator * (const drei_d &rhs); // Kreuzprodukt
  //bool input(drei_d& p); // obsolet
  //void output();         // obsolet
  // Stream-Ausgabe-Operator berladen
  friend ostream& operator << (ostream& output, const drei_d& p);
  friend istream& operator >> (istream& input, drei_d& p);
 };

#endif /* DREI_D_H_ */
