/*
 * P06A1.cpp
 *
 *  Created on: 19.05.2010
 *      Author: Oliver Jack
 */

#include <iostream>
#include <string>
#include "drei_d.h"

using namespace std;

// Zum Testen
#define check(v) \
    cout << " " << #v << " = " << v << endl;

#define test(v1, v2, v3, expr, note) \
    cout << "--------" << endl << "Test: " << note << endl; \
    cout << "pre:" << endl; \
    check(v1) \
    check(v2) \
    check(v3) \
    cout << "test case:" << endl; \
    cout << #expr << " = " << expr << endl; \
    cout << "post:" << endl; \
    check(v1) \
    check(v2) \
    check(v3) \
    cout << "--------" << endl;

int main()
{
    string combo = "Kombination der Operatoren";
    drei_d x(1, 2, 3), y(4, 5, 6), z(7, 8, 9);

    // Test Aufgabe 1
    test(x, y, z, x+y, "Addition")
    test(x, y, z, x-y, "Subtraktion")
    test(x, y, z, x.betrag(), "Betrag")
    test(x, y, z, x+y-z, combo)
    test(x, y, z, x-y+z, combo)
    test(x, y, z, x+y+z, combo)
    test(x, y, z, x-y-z, combo)
    test(x, y, z, x+x-x, combo)
    test(x, y, z, (z=x+y), "Zuweisung")
    test(x, y, z, (z=z), "Zuweisung")
    test(x, y, z, (z=x=y), "Zuweisung")

    // Test Aufgabe 2
    cout << "Bitte drei Vektoren eingeben: ";
    cin >> x >> y >> z;
    test(x, y, z, x*y, "Kreuzprodukt")
    // Test Kombination der Operatoren
    test(x, y, z, x+y*z, combo)
    test(x, y, z, (x+y)*z, combo)
    test(x, y, z, x+(y*z), combo)
    test(x, y, z, z*(x+y), combo)
    test(x, y, z, x*y*z, combo)
    test(x, y, z, x*(y=x-z)*z, combo)

    return (0);
}
